% modello di Leslie a 4 classi di et asintoticamente stabile

clear all; close all;

s0=0.9;
s1=0.8;
s2=0.5;
s3=0.2;
f1=0.1;
f2=0.2;
f3=0.3;
f4=0.1;
R=s0*f1+s0*s1*f2+s0*s1*s2*f3+s0*s1*s2*s3*f4

xin=[10 20 30 10]';
A=[s0*f1 s0*f2 s0*f3 s0*f4
    s1 0 0 0
    0 s2 0 0
    0 0 s3 0];
lD=max(abs(eig(A)))

classi=[xin;sum(xin)];
for t=1:15,
    dimensione=size(classi);
    x=A*classi(1:4,dimensione(2));
    classi=[classi [x;sum(x)]];
end; 

t=0:15;
figure; plot(t,classi(1:4,:),'*-');
legend('x1','x2','x3','x4');
title('senza immigrazione - classi di et');
%pause;

figure; plot(t,classi(5,:),'*-'); legend('Ntot');
title('senza immigrazione - popolazione totale Ntot');
%pause;

% calcolo lambda
Ntot=classi(5,:);
lambda=[];
for k=2:length(Ntot),
    lambda=[lambda Ntot(k)/Ntot(k-1)];
end;
figure;
plot(lambda,'*-'); legend('lambda');
title('senza immigrazione - lambda=Ntot(t+1)/Ntot(t)');
%pause;

% distribuzione di et
pigreco=[];
for k=1:length(classi),
    pigreco=[pigreco classi(1:4,k)/classi(5,k)];
end;
figure; plot(t,100*pigreco,'*-');
legend('p1','p2','p3','p4');
title('senza immigrazione - distribuzione di et pi=xi/Ntot');
%pause;

figure;
bar(t,100*pigreco')
legend('p1','p2','p3','p4');
title('senza immigrazione - distribuzione di et pi=xi/Ntot');
%pause;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% introduco immigrazione
xin=[10 20 30 10]';
A=[s0*f1 s0*f2 s0*f3 s0*f4
    s1 0 0 0
    0 s2 0 0
    0 0 s3 0];
classi=[xin;sum(xin)];
for t=1:15,
    dimensione=size(classi);
    x=A*classi(1:4,dimensione(2))+[10 10 0 0]';
    classi=[classi [x;sum(x)]];
end; 

t=0:15;
figure; plot(t,classi(1:4,:),'*-');
legend('x1','x2','x3','x4');
title('con immigrazione - classi di et');
%pause;

figure; plot(t,classi(5,:),'*-'); legend('Ntot');
title('con immigrazione - popolazione totale Ntot');
%pause;

% distribuzione di et
pigreco=[];
for k=1:length(classi),
    pigreco=[pigreco classi(1:4,k)/classi(5,k)];
end;
figure; plot(t,100*pigreco,'*-');
legend('p1','p2','p3','p4');
title('con immigrazione - distribuzione di et pi=xi/Ntot');
%pause;

figure;
bar(t,100*pigreco')
legend('p1','p2','p3','p4');
title('con immigrazione - distribuzione di et pi=xi/Ntot');
%pause;
